PingSnitch = CreateFrame("Frame", nil, UIParent)

function PingSnitch:Initialize()
	self.snitchFormat = "PingSnitch: Minimap ping from %s"
	self.previousSender = nil
	self.previousTime = nil

	self:SetScript("OnEvent", function (self, ...) self:OnEvent(...) end)
	self:RegisterEvent("MINIMAP_PING")
end

function PingSnitch:OnEvent(pEvent, ...)
	local sender = UnitName(select(1, ...))
	local time = GetTime()
	
	-- Ignore the player's own pings
	if sender == UnitName("player") then
		return
	end

	-- Ignore repeated pings from the same player
	if sender == self.previousSender
	and self.previousTime
	and (time - self.previousTime) < 10 then
		return
	end

	-- Report the ping
	DEFAULT_CHAT_FRAME:AddMessage(self.snitchFormat:format(sender), 0.7, 0.3, 1.0);
	
	-- Remember who sent the last ping
	self.previousSender = sender
	self.previousTime = time
end

PingSnitch:Initialize()
